package winterwell.utils;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * Annotation for use with UnitTestRunner. Add this to fields in the settings
 * object to get it to ignore methods. Ideally there should be a comment after
 * it explaining why UTR isn't to be run in this instance.
 */
@Retention(RetentionPolicy.RUNTIME)
// Meta-annotation for "Don't throw this away during compilation"
@Target({ ElementType.METHOD })
// Meta-annotation for "Only allowed on fields"
public @interface NoUTR {
}