/**
 * 
 */
package winterwell.utils.io;

/**
 * EXPERIMENTAL Base class for stream/pipeline processors
 * 
 * @author Joe Halliwell <joe@winterwell.com>
 * 
 */
public abstract class AObjectStreamProcessor<X> extends AObjectStream<X> {

	AObjectStream<X> source;

	/**
	 * Constuct a new processor appended to the source pipeline
	 */
	public AObjectStreamProcessor(AObjectStream<X> source) {
		super();
		this.source = source;
	}

	/**
	 * Reset this element throwing away any internal state e.g. buffers, stats.
	 * Called when the source is changed.
	 */
	public abstract void reset();

	/**
	 * Set the ultimate source of this pipeline
	 * 
	 * @param source
	 */
	public void setSource(AObjectStream<X> source) {
		if (this.source instanceof AObjectStreamProcessor) {
			((AObjectStreamProcessor<X>) source).setSource(source);
		} else {
			this.source = source;
		}
	}

}
